//Dzieki temu naglowkowi mozemy korzystac ze zmiennych typu uint32_t itp.
#include <stdint.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_timer_regs.h"

#include "sys/alt_irq.h"

#include "7SEG.h"
#include "KBD.h"

volatile uint16_t counter = 0;

void timer0Interrupt(void* context){
	IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER0_BASE, 0);
	refreshDisplay();
	// ponisza linijka dotyczy zaawansowanej obsugi przyciskw przez timer
	kbdCheck();

	// ponisze linijki dotycz prostej eliminacji drga stykw
	/*static uint16_t msCounter = 0;
	uint16_t state = IORD_ALTERA_AVALON_PIO_DATA(SW_BASE);
	if(state != 0b111){
		if(msCounter < 50){
			msCounter++;
		}else if(msCounter == 50){
			counter++;
			intDisplayDec(counter);
			msCounter++;
		}
	}else{
		msCounter = 0;
	}*/
}

// ponisze linijki dotycz obsugi przyciskw poprzez przerwanie
/*void SWInterrupt(void* context){
	static uint16_t counter = 0;

	IOWR_ALTERA_AVALON_PIO_EDGE_CAP(SW_BASE, 0);

	counter ++;
	intDisplayDec(counter);
}*/

// ponisze 3 funkcje dotycz zaawansowanej obsugi przyciskw przez timer
void counterInc(uint8_t param){
	counter++;
	if(counter > 9999) counter = 0;
	intDisplayDec(counter);
}

void counterDec(uint8_t param){
	counter--;
	if(counter > 9999) counter = 9999;
	intDisplayDec(counter);
}

void counterRst(uint8_t param){
	if(param == 0){
		counter = 0;
	}else{
		counter = 9999;
	}
	intDisplayDec(counter);
}

int main()
{ 
	alt_putstr("Hello from Nios II!\n");

	alt_ic_isr_register(TIMER0_IRQ_INTERRUPT_CONTROLLER_ID, TIMER0_IRQ, timer0Interrupt, NULL, NULL);

	IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER0_BASE, ALTERA_AVALON_TIMER_CONTROL_START_MSK |
		ALTERA_AVALON_TIMER_CONTROL_CONT_MSK | ALTERA_AVALON_TIMER_CONTROL_ITO_MSK );

	// ponisze linijki dotycz obsugi przyciskw poprzez przerwanie
	/*alt_ic_isr_register(SW_IRQ_INTERRUPT_CONTROLLER_ID, SW_IRQ, SWInterrupt, NULL, NULL);

	IOWR_ALTERA_AVALON_PIO_IRQ_MASK(SW_BASE, 0b111);*/

	// ponisze linijki dotycz zaawansowanej obsugi przyciskw przez timer
	// definiujemy tu dziaania dla kliknic i przytrzyma rnych przyciskw
	menu_items[KBD_S3].click.action = counterInc;
	menu_items[KBD_S3].hold.action = counterInc;
	menu_items[KBD_S2].click.action = counterDec;
	menu_items[KBD_S2].hold.action = counterDec;
	// w wypadku przycisku reset dla kliknicia i ptzrtrzymania wywoamy t sam funkcj...
	menu_items[KBD_S1].click.action = counterRst;
	// ...ale z rnymi parametrami!
	menu_items[KBD_S1].click.parameter = 0;
	menu_items[KBD_S1].hold.action = counterRst;
	menu_items[KBD_S1].hold.parameter = 1;

	intDisplayDec(0);

	/* Event loop never exits. */
	while (1){

	}

	return 0;
}
