//Dzieki temu naglowkowi mozemy korzystac ze zmiennych typu uint32_t itp.
#include <stdint.h>
#include <stdio.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_timer_regs.h"

#include "sys/alt_irq.h"

#include "7SEG.h"
#include "KBD.h"

volatile uint16_t counterMs = 0;

void timer0Interrupt(void* context){
	IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER0_BASE, 0);
	refreshDisplay();

	counterMs++;

}


int main()
{ 
	alt_putstr("Hello from Nios II!\n");

	alt_ic_isr_register(TIMER0_IRQ_INTERRUPT_CONTROLLER_ID, TIMER0_IRQ, timer0Interrupt, NULL, NULL);

	IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER0_BASE, ALTERA_AVALON_TIMER_CONTROL_START_MSK |
		ALTERA_AVALON_TIMER_CONTROL_CONT_MSK | ALTERA_AVALON_TIMER_CONTROL_ITO_MSK );

	intDisplayDec(0);



	/* Event loop never exits. */
	while (1){
		// w pętli while
		if(!(IORD_ALTERA_AVALON_PIO_DATA(SW_BASE) & (1<<0))){
			alt_irq_context context = alt_irq_disable_all();

			IOWR_ALTERA_AVALON_TIMER_SNAPH(TIMER0_BASE, 0);
			uint16_t copyMs = counterMs;

			uint8_t valid = !(IORD_ALTERA_AVALON_TIMER_STATUS(TIMER0_BASE) & ALTERA_AVALON_TIMER_STATUS_TO_MSK);

			alt_irq_enable_all(context);

			uint32_t timerValue = IORD_ALTERA_AVALON_TIMER_SNAPH(TIMER0_BASE);
			timerValue <<= 16;
			timerValue |= IORD_ALTERA_AVALON_TIMER_SNAPL(TIMER0_BASE);

			printf("T = %u.%03lu ms %c \r\n", copyMs, 999-timerValue/50, valid?' ':'*');
			intDisplayDec(copyMs);

			while(!(IORD_ALTERA_AVALON_PIO_DATA(SW_BASE) & (1<<0)));
		}
	}

	return 0;
}
